> This page is for Afterpay.

> For clean Markdown of any page, append .md to the page URL.
> For a complete documentation index, see https://developers.cash.app/llms.txt.
> For AI client integration (Claude Code, Cursor, etc.), connect to the MCP server at https://developers.cash.app/_mcp/server.

# Cancel Billing Agreement (Alternative)

PUT https://global-api-sandbox.afterpay.com/v2/billing-agreements/cancel
Content-Type: application/json

Alternative endpoint to cancel a billing agreement using a request body instead of path parameter.
Functionally equivalent to DELETE /v2/billing-agreements/\{token}.

*Deprecated. For new integrations, see [Grants](https://afterpay.docs.buildwithfern.com/afterpay-online-developer/api-reference/reference/grants/start-grant-approval).*

Reference: https://developers.cash.app/afterpay/api-reference/reference/billing-agreements-deprecated/cancel-billing-agreement-alt

## Authentication

- `Authorization` header (basic auth, required) — Basic authentication of the form `Basic <base64(username:password)>`.

## Servers

- `https://global-api-sandbox.afterpay.com` (Sandbox, default)
- `https://global-api.afterpay.com` (Production)

## Request

### Headers

- `Accept` ("application/json", required)

### Body (application/json)

This endpoint expects an object.

- `token` (string, required) — The billing agreement token to cancel

## Response

### 200

Billing agreement cancelled successfully

- `token` (string, required) — Unique token identifying the agreement
- `type` ("BILLING", required) — Type of agreement
- `status` (enum, required) — Current status of the agreement
  - Allowed values: `ACTIVE`, `CANCELLED`, `EXPIRED`, `PENDING_RENEWAL`, `PENDING_RENEWAL_EXPIRED`
- `created` (datetime, required) — Timestamp when the agreement was created
- `merchantReference` (string, optional) — Merchant's reference for this agreement
- `cancelled` (datetime, optional) — If present, indicates when the agreement was cancelled
- `expires` (datetime, optional) — If present, indicates when the agreement's status will become EXPIRED, preventing a client from using it to create payments
- `events` (list of AgreementEventResponse, optional) — List of events associated with this agreement
- `requestId` (string, optional) — Unique identifier for the request
- `consumerReference` (string, optional) — Reference identifier for the consumer
- `email` (string, optional) — Masked email address of the consumer

## Errors

### 403 Cancel Billing Agreement Alt Request Forbidden Error

| errorCode | Description | | --- | --- | | billing_agreement_not_authorised | Recurring payments are not enabled for this merchant. |

- `any`

### 404 Cancel Billing Agreement Alt Request Not Found Error

| errorCode | Description | | --- | --- | | billing_agreement_not_found | The specified billing agreement token was not found. |

- `any`

## Types

### AgreementEventResponse

Response type for agreement events

- `type` (enum, optional) — Type of event
  - Allowed values: `CAPTURE`, `VOID`
- `created` (datetime, optional) — Timestamp when the event occurred
- `amount` (Money, optional) — Amount associated with the event
- `status` (enum, optional) — Status of the agreement at the time of the event
  - Allowed values: `APPROVED`, `DECLINED`
- `merchantReference` (string, optional) — Merchant's reference associated with this event
- `orderId` (double, optional) — Order ID associated with this event

### Money

Object containing amount and currency

- `amount` (string, required) — The amount as a string representation of a decimal number, rounded to 2 decimal places.
- `currency` (enum, required)
  - Allowed values: `AUD`, `NZD`, `USD`, `CAD`, `GBP`

## Examples

**Request**

```json
{
  "token": "ba_def456ghi789"
}
```

**Response**

```json
{
  "token": "005.2fkv5o963b132z8ppa34srlh60987y87d55re237wsg9tr4q2",
  "type": "BILLING",
  "status": "ACTIVE",
  "created": "2024-03-04T12:00:00Z",
  "merchantReference": "merchant_ref_123",
  "cancelled": "2024-03-05T12:00:00Z",
  "expires": "2025-03-04T12:00:00Z",
  "events": [
    {
      "type": "CAPTURE",
      "created": "2024-03-04T10:30:00Z",
      "amount": {
        "amount": "100.00",
        "currency": "AUD"
      },
      "status": "APPROVED",
      "merchantReference": "merchant-event-ref-789",
      "orderId": 123
    }
  ],
  "requestId": "req_abc123def456",
  "consumerReference": "cust_12345",
  "email": "j***@e***.com"
}
```

**SDK Code**

```python
import requests

url = "https://global-api-sandbox.afterpay.com/v2/billing-agreements/cancel"

payload = { "token": "ba_def456ghi789" }
headers = {
    "Accept": "application/json"
    "Content-Type": "application/json"
}

response = requests.put(url, json=payload, headers=headers, auth=("<username>", "<password>"))

print(response.json())
```

```javascript
const url = 'https://global-api-sandbox.afterpay.com/v2/billing-agreements/cancel';
const credentials = btoa("<username>:<password>");

const options = {
  method: 'PUT',
  headers: {
    Accept: 'application/json',
    Authorization: `Basic ${credentials}`,
    'Content-Type': 'application/json'
  },
  body: '{"token":"ba_def456ghi789"}'
};

try {
  const response = await fetch(url, options);
  const data = await response.json();
  console.log(data);
} catch (error) {
  console.error(error);
}
```

```go
package main

import (
	"fmt"
	"strings"
	"net/http"
	"io"
)

func main() {

	url := "https://global-api-sandbox.afterpay.com/v2/billing-agreements/cancel"

	payload := strings.NewReader("{\n  \"token\": \"ba_def456ghi789\"\n}")

	req, _ := http.NewRequest("PUT", url, payload)

	req.Header.Add("Accept", "application/json")
	req.SetBasicAuth("<username>", "<password>")
	req.Header.Add("Content-Type", "application/json")

	res, _ := http.DefaultClient.Do(req)

	defer res.Body.Close()
	body, _ := io.ReadAll(res.Body)

	fmt.Println(res)
	fmt.Println(string(body))

}
```

```ruby
require 'uri'
require 'net/http'

url = URI("https://global-api-sandbox.afterpay.com/v2/billing-agreements/cancel")

http = Net::HTTP.new(url.host, url.port)
http.use_ssl = true

request = Net::HTTP::Put.new(url)
request["Accept"] = 'application/json'
request.basic_auth("<username>", "<password>")
request["Content-Type"] = 'application/json'
request.body = "{\n  \"token\": \"ba_def456ghi789\"\n}"

response = http.request(request)
puts response.read_body
```

```java
import com.mashape.unirest.http.HttpResponse;
import com.mashape.unirest.http.Unirest;

HttpResponse<String> response = Unirest.put("https://global-api-sandbox.afterpay.com/v2/billing-agreements/cancel")
  .header("Accept", "application/json")
  .basicAuth("<username>", "<password>")
  .header("Content-Type", "application/json")
  .body("{\n  \"token\": \"ba_def456ghi789\"\n}")
  .asString();
```

```php
<?php
require_once('vendor/autoload.php');

$client = new \GuzzleHttp\Client();

$response = $client->request('PUT', 'https://global-api-sandbox.afterpay.com/v2/billing-agreements/cancel', [
  'body' => '{
  "token": "ba_def456ghi789"
}',
  'headers' => [
    'Accept' => 'application/json',
    'Content-Type' => 'application/json',
  ],
    'auth' => ['<username>', '<password>'],
]);

echo $response->getBody();
```

```csharp
using RestSharp;
using RestSharp.Authenticators;

var client = new RestClient("https://global-api-sandbox.afterpay.com/v2/billing-agreements/cancel");
client.Authenticator = new HttpBasicAuthenticator("<username>", "<password>");
var request = new RestRequest(Method.PUT);
request.AddHeader("Accept", "application/json");

request.AddHeader("Content-Type", "application/json");
request.AddParameter("application/json", "{\n  \"token\": \"ba_def456ghi789\"\n}", ParameterType.RequestBody);
IRestResponse response = client.Execute(request);
```

```swift
import Foundation

let credentials = Data("<username>:<password>".utf8).base64EncodedString()

let headers = [
  "Accept": "application/json",
  "Authorization": "Basic \(credentials)",
  "Content-Type": "application/json"
]
let parameters = ["token": "ba_def456ghi789"] as [String : Any]

let postData = JSONSerialization.data(withJSONObject: parameters, options: [])

let request = NSMutableURLRequest(url: NSURL(string: "https://global-api-sandbox.afterpay.com/v2/billing-agreements/cancel")! as URL,
                                        cachePolicy: .useProtocolCachePolicy,
                                    timeoutInterval: 10.0)
request.httpMethod = "PUT"
request.allHTTPHeaderFields = headers
request.httpBody = postData as Data

let session = URLSession.shared
let dataTask = session.dataTask(with: request as URLRequest, completionHandler: { (data, response, error) -> Void in
  if (error != nil) {
    print(error as Any)
  } else {
    let httpResponse = response as? HTTPURLResponse
    print(httpResponse)
  }
})

dataTask.resume()
```